module Model.Board where

import Dict
import List

import Model.Piece    (..)
import Model.Position (..)

type alias Board = Dict.Dict Position Piece

initial = Dict.fromList <|
    [ (a1, WhiteRook  )
    , (b1, WhiteKnight)
    , (c1, WhiteBishop)
    , (d1, WhiteQueen )
    , (e1, WhiteKing  )
    , (f1, WhiteBishop)
    , (g1, WhiteKnight)
    , (h1, WhiteRook  ) ]

    ++ List.map (\p -> (p, WhitePawn)) (rank 2)

    ++ List.map (\p -> (p, BlackPawn)) (rank 7)

    ++ [ (a8, BlackRook  )
       , (b8, BlackKnight)
       , (c8, BlackBishop)
       , (d8, BlackQueen )
       , (e8, BlackKing  )
       , (f8, BlackBishop)
       , (g8, BlackKnight)
       , (h8, BlackRook  ) ]
