module Util where

import List (..)

takeWhile : (a -> Bool) -> List a -> List a
takeWhile p xs =
    case xs of
        []      -> []
        (y::ys) -> if p y
            then y::takeWhile p ys
            else []

dropWhile : (a -> Bool) -> List a -> List a
dropWhile p xs =
    case xs of
        []      -> []
        (y::ys) -> if p y
            then dropWhile p ys
            else y::ys

span : (a -> Bool) -> List a -> (List a, List a)
span p xs =
    case xs of
        []      -> ([], [])
        (y::ys) ->
            let (zs, ws) = span p ys
            in if p y
                then (y::zs, ws)
                else ([], y::ys)
